/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { ProjectRoleDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { ProjectRoleDtoResponse } from '../../@coscine/model';
// @ts-ignore
import type { ProjectRoleForProjectCreationDto } from '../../@coscine/model';
// @ts-ignore
import type { ProjectRoleForProjectManipulationDto } from '../../@coscine/model';
/**
 * ProjectMemberApi - axios parameter creator
 * @export
 */
export const ProjectMemberApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Creates a project membership for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {ProjectRoleForProjectCreationDto} [projectRoleForProjectCreationDto] The project membership data for creation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        addMembership: async (projectId: string, projectRoleForProjectCreationDto?: ProjectRoleForProjectCreationDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('addMembership', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/members`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(projectRoleForProjectCreationDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdMembersOptions: async (projectId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('apiV2ProjectsProjectIdMembersOptions', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/members`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Deletes a project membership for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} membershipId The ID of the project membership to delete.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteMembership: async (projectId: string, membershipId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('deleteMembership', 'projectId', projectId)
            // verify required parameter 'membershipId' is not null or undefined
            assertParamExists('deleteMembership', 'membershipId', membershipId)
            const localVarPath = `/api/v2/projects/{projectId}/members/{membershipId}`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"membershipId"}}`, encodeURIComponent(String(membershipId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves a project membership for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} membershipId The ID of the project membership to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMembership: async (projectId: string, membershipId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getMembership', 'projectId', projectId)
            // verify required parameter 'membershipId' is not null or undefined
            assertParamExists('getMembership', 'membershipId', membershipId)
            const localVarPath = `/api/v2/projects/{projectId}/members/{membershipId}`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"membershipId"}}`, encodeURIComponent(String(membershipId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves all project memberships for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMemberships: async (projectId: string, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getMemberships', 'projectId', projectId)
            const localVarPath = `/api/v2/projects/{projectId}/members`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Updates a project membership for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} membershipId The ID of the project membership to update.
         * @param {ProjectRoleForProjectManipulationDto} [projectRoleForProjectManipulationDto] The updated project membership data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateMembership: async (projectId: string, membershipId: string, projectRoleForProjectManipulationDto?: ProjectRoleForProjectManipulationDto, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('updateMembership', 'projectId', projectId)
            // verify required parameter 'membershipId' is not null or undefined
            assertParamExists('updateMembership', 'membershipId', membershipId)
            const localVarPath = `/api/v2/projects/{projectId}/members/{membershipId}`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"membershipId"}}`, encodeURIComponent(String(membershipId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(projectRoleForProjectManipulationDto, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ProjectMemberApi - functional programming interface
 * @export
 */
export const ProjectMemberApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ProjectMemberApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Creates a project membership for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {ProjectRoleForProjectCreationDto} [projectRoleForProjectCreationDto] The project membership data for creation.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async addMembership(projectId: string, projectRoleForProjectCreationDto?: ProjectRoleForProjectCreationDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectRoleDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.addMembership(projectId, projectRoleForProjectCreationDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectMemberApi.addMembership']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2ProjectsProjectIdMembersOptions(projectId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2ProjectsProjectIdMembersOptions(projectId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectMemberApi.apiV2ProjectsProjectIdMembersOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Deletes a project membership for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} membershipId The ID of the project membership to delete.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteMembership(projectId: string, membershipId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteMembership(projectId, membershipId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectMemberApi.deleteMembership']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves a project membership for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} membershipId The ID of the project membership to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getMembership(projectId: string, membershipId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectRoleDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getMembership(projectId, membershipId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectMemberApi.getMembership']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves all project memberships for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getMemberships(projectId: string, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectRoleDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getMemberships(projectId, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectMemberApi.getMemberships']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Updates a project membership for a specified project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} membershipId The ID of the project membership to update.
         * @param {ProjectRoleForProjectManipulationDto} [projectRoleForProjectManipulationDto] The updated project membership data.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateMembership(projectId: string, membershipId: string, projectRoleForProjectManipulationDto?: ProjectRoleForProjectManipulationDto, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateMembership(projectId, membershipId, projectRoleForProjectManipulationDto, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectMemberApi.updateMembership']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ProjectMemberApi - factory interface
 * @export
 */
export const ProjectMemberApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ProjectMemberApiFp(configuration)
    return {
        /**
         * 
         * @summary Creates a project membership for a specified project.
         * @param {ProjectMemberApiAddMembershipRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        addMembership(requestParameters: ProjectMemberApiAddMembershipRequest, options?: RawAxiosRequestConfig): AxiosPromise<ProjectRoleDtoResponse> {
            return localVarFp.addMembership(requestParameters.projectId, requestParameters.projectRoleForProjectCreationDto, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {ProjectMemberApiApiV2ProjectsProjectIdMembersOptionsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdMembersOptions(requestParameters: ProjectMemberApiApiV2ProjectsProjectIdMembersOptionsRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2ProjectsProjectIdMembersOptions(requestParameters.projectId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Deletes a project membership for a specified project.
         * @param {ProjectMemberApiDeleteMembershipRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteMembership(requestParameters: ProjectMemberApiDeleteMembershipRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.deleteMembership(requestParameters.projectId, requestParameters.membershipId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves a project membership for a specified project.
         * @param {ProjectMemberApiGetMembershipRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMembership(requestParameters: ProjectMemberApiGetMembershipRequest, options?: RawAxiosRequestConfig): AxiosPromise<ProjectRoleDtoResponse> {
            return localVarFp.getMembership(requestParameters.projectId, requestParameters.membershipId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves all project memberships for a specified project.
         * @param {ProjectMemberApiGetMembershipsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMemberships(requestParameters: ProjectMemberApiGetMembershipsRequest, options?: RawAxiosRequestConfig): AxiosPromise<ProjectRoleDtoPagedResponse> {
            return localVarFp.getMemberships(requestParameters.projectId, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Updates a project membership for a specified project.
         * @param {ProjectMemberApiUpdateMembershipRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateMembership(requestParameters: ProjectMemberApiUpdateMembershipRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.updateMembership(requestParameters.projectId, requestParameters.membershipId, requestParameters.projectRoleForProjectManipulationDto, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for addMembership operation in ProjectMemberApi.
 * @export
 * @interface ProjectMemberApiAddMembershipRequest
 */
export interface ProjectMemberApiAddMembershipRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectMemberApiAddMembership
     */
    readonly projectId: string

    /**
     * The project membership data for creation.
     * @type {ProjectRoleForProjectCreationDto}
     * @memberof ProjectMemberApiAddMembership
     */
    readonly projectRoleForProjectCreationDto?: ProjectRoleForProjectCreationDto
}

/**
 * Request parameters for apiV2ProjectsProjectIdMembersOptions operation in ProjectMemberApi.
 * @export
 * @interface ProjectMemberApiApiV2ProjectsProjectIdMembersOptionsRequest
 */
export interface ProjectMemberApiApiV2ProjectsProjectIdMembersOptionsRequest {
    /**
     * 
     * @type {string}
     * @memberof ProjectMemberApiApiV2ProjectsProjectIdMembersOptions
     */
    readonly projectId: string
}

/**
 * Request parameters for deleteMembership operation in ProjectMemberApi.
 * @export
 * @interface ProjectMemberApiDeleteMembershipRequest
 */
export interface ProjectMemberApiDeleteMembershipRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectMemberApiDeleteMembership
     */
    readonly projectId: string

    /**
     * The ID of the project membership to delete.
     * @type {string}
     * @memberof ProjectMemberApiDeleteMembership
     */
    readonly membershipId: string
}

/**
 * Request parameters for getMembership operation in ProjectMemberApi.
 * @export
 * @interface ProjectMemberApiGetMembershipRequest
 */
export interface ProjectMemberApiGetMembershipRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectMemberApiGetMembership
     */
    readonly projectId: string

    /**
     * The ID of the project membership to retrieve.
     * @type {string}
     * @memberof ProjectMemberApiGetMembership
     */
    readonly membershipId: string
}

/**
 * Request parameters for getMemberships operation in ProjectMemberApi.
 * @export
 * @interface ProjectMemberApiGetMembershipsRequest
 */
export interface ProjectMemberApiGetMembershipsRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectMemberApiGetMemberships
     */
    readonly projectId: string

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof ProjectMemberApiGetMemberships
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof ProjectMemberApiGetMemberships
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof ProjectMemberApiGetMemberships
     */
    readonly orderBy?: string
}

/**
 * Request parameters for updateMembership operation in ProjectMemberApi.
 * @export
 * @interface ProjectMemberApiUpdateMembershipRequest
 */
export interface ProjectMemberApiUpdateMembershipRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectMemberApiUpdateMembership
     */
    readonly projectId: string

    /**
     * The ID of the project membership to update.
     * @type {string}
     * @memberof ProjectMemberApiUpdateMembership
     */
    readonly membershipId: string

    /**
     * The updated project membership data.
     * @type {ProjectRoleForProjectManipulationDto}
     * @memberof ProjectMemberApiUpdateMembership
     */
    readonly projectRoleForProjectManipulationDto?: ProjectRoleForProjectManipulationDto
}

/**
 * ProjectMemberApi - object-oriented interface
 * @export
 * @class ProjectMemberApi
 * @extends {BaseAPI}
 */
export class ProjectMemberApi extends BaseAPI {
    /**
     * 
     * @summary Creates a project membership for a specified project.
     * @param {ProjectMemberApiAddMembershipRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectMemberApi
     */
    public addMembership(requestParameters: ProjectMemberApiAddMembershipRequest, options?: RawAxiosRequestConfig) {
        return ProjectMemberApiFp(this.configuration).addMembership(requestParameters.projectId, requestParameters.projectRoleForProjectCreationDto, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {ProjectMemberApiApiV2ProjectsProjectIdMembersOptionsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectMemberApi
     */
    public apiV2ProjectsProjectIdMembersOptions(requestParameters: ProjectMemberApiApiV2ProjectsProjectIdMembersOptionsRequest, options?: RawAxiosRequestConfig) {
        return ProjectMemberApiFp(this.configuration).apiV2ProjectsProjectIdMembersOptions(requestParameters.projectId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Deletes a project membership for a specified project.
     * @param {ProjectMemberApiDeleteMembershipRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectMemberApi
     */
    public deleteMembership(requestParameters: ProjectMemberApiDeleteMembershipRequest, options?: RawAxiosRequestConfig) {
        return ProjectMemberApiFp(this.configuration).deleteMembership(requestParameters.projectId, requestParameters.membershipId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves a project membership for a specified project.
     * @param {ProjectMemberApiGetMembershipRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectMemberApi
     */
    public getMembership(requestParameters: ProjectMemberApiGetMembershipRequest, options?: RawAxiosRequestConfig) {
        return ProjectMemberApiFp(this.configuration).getMembership(requestParameters.projectId, requestParameters.membershipId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves all project memberships for a specified project.
     * @param {ProjectMemberApiGetMembershipsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectMemberApi
     */
    public getMemberships(requestParameters: ProjectMemberApiGetMembershipsRequest, options?: RawAxiosRequestConfig) {
        return ProjectMemberApiFp(this.configuration).getMemberships(requestParameters.projectId, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Updates a project membership for a specified project.
     * @param {ProjectMemberApiUpdateMembershipRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectMemberApi
     */
    public updateMembership(requestParameters: ProjectMemberApiUpdateMembershipRequest, options?: RawAxiosRequestConfig) {
        return ProjectMemberApiFp(this.configuration).updateMembership(requestParameters.projectId, requestParameters.membershipId, requestParameters.projectRoleForProjectManipulationDto, options).then((request) => request(this.axios, this.basePath));
    }
}

